#include "Position.h"
#include <iostream>
using namespace std;

Position::Position() {
	this->row = 1;
	this->column = 'A';
}

Position::Position(int row, char column) {
	this->setPosition(row, column);
}

void Position::setPosition(int row, char column) {
	this->row = row >= ROW_MIN && row <= ROW_MAX ? row : ROW_MIN;
	this->column = column >= COL_MIN && column <= COL_MAX ? column : COL_MIN;
}

void Position::print() {
	cout << this->column << this->row << endl;
}

void Position::move(Direction direction) {
	switch (direction) {
	case UP:
		if (this->row < 8) this->row += 1;
		break;
	case LEFT:
		if (this->column > 'A') this->column -= 1;
		break;
	case DOWN:
		if (this->row > 1) this->row -= 1;
		break;
	case RIGHT:
		if (this->column < 'H') this->column += 1;
		break;
	default:
		break;
	}
}

bool Position::sameDirection(Position* other) {
	return this->row == other->row || this->column == other->column;
}

bool Position::samePosition(Position* other) {
	return this->row == other->row && this->column == other->column;
}

int Position::getRow() {
	return this->row;
}

char Position::getColumn() {
	return this->column;
}
